/*
 * This file was generated by the CommonAPI Generators.
 * Used org.genivi.commonapi.someip 3.2.0.v202012010944.
 * Used org.franca.core 0.13.1.201807231814.
 *
 * This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
 * If a copy of the MPL was not distributed with this file, You can obtain one at
 * http://mozilla.org/MPL/2.0/.
 */
#include <v0/commonapi/demo/DemoApp1SomeIPProxy.hpp>

#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#define HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE
#endif

#include <CommonAPI/SomeIP/AddressTranslator.hpp>

#if defined (HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE)
#undef COMMONAPI_INTERNAL_COMPILATION
#undef HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE
#endif

namespace v0 {
namespace commonapi {
namespace demo {

std::shared_ptr<CommonAPI::SomeIP::Proxy> createDemoApp1SomeIPProxy(
    const CommonAPI::SomeIP::Address &_address,
    const std::shared_ptr<CommonAPI::SomeIP::ProxyConnection> &_connection) {
    return std::make_shared< DemoApp1SomeIPProxy>(_address, _connection);
}

void initializeDemoApp1SomeIPProxy() {
    CommonAPI::SomeIP::AddressTranslator::get()->insert(
        "local:commonapi.demo.DemoApp1:v0_1:commonapi.demo.DemoApp1",
        0x1234, 0x5678, 0, 1);
    CommonAPI::SomeIP::Factory::get()->registerProxyCreateMethod(
        "commonapi.demo.DemoApp1:v0_1",
        &createDemoApp1SomeIPProxy);
}

INITIALIZER(registerDemoApp1SomeIPProxy) {
    CommonAPI::SomeIP::Factory::get()->registerInterface(initializeDemoApp1SomeIPProxy);
}

DemoApp1SomeIPProxy::DemoApp1SomeIPProxy(
    const CommonAPI::SomeIP::Address &_address,
    const std::shared_ptr<CommonAPI::SomeIP::ProxyConnection> &_connection)
        : CommonAPI::SomeIP::Proxy(_address, _connection),
          uiDemoAttr1_(*this, CommonAPI::SomeIP::eventgroup_id_t(0x1b5a), CommonAPI::SomeIP::event_id_t(0x80f4), CommonAPI::SomeIP::method_id_t(0xbbb), false, CommonAPI::SomeIP::reliability_type_e::RT_UNRELIABLE, false, CommonAPI::SomeIP::method_id_t(0xbbc), false, static_cast< CommonAPI::SomeIP::IntegerDeployment<int32_t>* >(nullptr)),
          a1Demo_(*this, CommonAPI::SomeIP::eventgroup_id_t(0x1b5b), CommonAPI::SomeIP::event_id_t(0x80f5), CommonAPI::SomeIP::method_id_t(0xbbd), false, CommonAPI::SomeIP::reliability_type_e::RT_UNRELIABLE, false, CommonAPI::SomeIP::method_id_t(0xbbe), false, static_cast< ::v0::commonapi::demo::CommonTypes_::a1StructDeployment_t* >(nullptr)),
          demoStatus1_(*this, 0x1b58, CommonAPI::SomeIP::event_id_t(0x80f2), CommonAPI::SomeIP::event_type_e::ET_EVENT , CommonAPI::SomeIP::reliability_type_e::RT_UNRELIABLE, false, std::make_tuple(static_cast< CommonAPI::SomeIP::IntegerDeployment<int32_t>* >(nullptr))),
          demoStatus2_(*this, 0x1b59, CommonAPI::SomeIP::event_id_t(0x80f3), CommonAPI::SomeIP::event_type_e::ET_EVENT , CommonAPI::SomeIP::reliability_type_e::RT_UNRELIABLE, false, std::make_tuple())
{
}

DemoApp1SomeIPProxy::~DemoApp1SomeIPProxy() {
    completed_.set_value();
}

DemoApp1SomeIPProxy::UiDemoAttr1Attribute& DemoApp1SomeIPProxy::getUiDemoAttr1Attribute() {
    return uiDemoAttr1_;
}
DemoApp1SomeIPProxy::A1DemoAttribute& DemoApp1SomeIPProxy::getA1DemoAttribute() {
    return a1Demo_;
}

DemoApp1SomeIPProxy::DemoStatus1Event& DemoApp1SomeIPProxy::getDemoStatus1Event() {
    return demoStatus1_;
}
DemoApp1SomeIPProxy::DemoStatus2Event& DemoApp1SomeIPProxy::getDemoStatus2Event() {
    return demoStatus2_;
}

void DemoApp1SomeIPProxy::DemoMethod1(std::string _name, CommonAPI::CallStatus &_internalCallStatus, std::string &_message, const CommonAPI::CallInfo *_info) {
    CommonAPI::Deployable< std::string, CommonAPI::SomeIP::StringDeployment> deploy_name(_name, &::v0::commonapi::demo::DemoApp1_::DemoMethod1_nameDeployment);
    CommonAPI::Deployable< std::string, CommonAPI::SomeIP::StringDeployment> deploy_message(&::v0::commonapi::demo::DemoApp1_::DemoMethod1_messageDeployment);
    CommonAPI::SomeIP::ProxyHelper<
        CommonAPI::SomeIP::SerializableArguments<
            CommonAPI::Deployable<
                std::string,
                CommonAPI::SomeIP::StringDeployment
            >
        >,
        CommonAPI::SomeIP::SerializableArguments<
            CommonAPI::Deployable<
                std::string,
                CommonAPI::SomeIP::StringDeployment
            >
        >
    >::callMethodWithReply(
        *this,
        CommonAPI::SomeIP::method_id_t(0x7530),
        false,
        false,
        (_info ? _info : &CommonAPI::SomeIP::defaultCallInfo),
        deploy_name,
        _internalCallStatus,
        deploy_message);
    _message = deploy_message.getValue();
}

std::future<CommonAPI::CallStatus> DemoApp1SomeIPProxy::DemoMethod1Async(const std::string &_name, DemoMethod1AsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    CommonAPI::Deployable< std::string, CommonAPI::SomeIP::StringDeployment> deploy_name(_name, &::v0::commonapi::demo::DemoApp1_::DemoMethod1_nameDeployment);
    CommonAPI::Deployable< std::string, CommonAPI::SomeIP::StringDeployment> deploy_message(&::v0::commonapi::demo::DemoApp1_::DemoMethod1_messageDeployment);
    return CommonAPI::SomeIP::ProxyHelper<
        CommonAPI::SomeIP::SerializableArguments<
            CommonAPI::Deployable<
                std::string,
                CommonAPI::SomeIP::StringDeployment
            >
        >,
        CommonAPI::SomeIP::SerializableArguments<
            CommonAPI::Deployable<
                std::string,
                CommonAPI::SomeIP::StringDeployment
            >
        >
    >::callMethodAsync(
        *this,
        CommonAPI::SomeIP::method_id_t(0x7530),
        false,
        false,
        (_info ? _info : &CommonAPI::SomeIP::defaultCallInfo),
        deploy_name,
        [_callback] (CommonAPI::CallStatus _internalCallStatus, CommonAPI::Deployable< std::string, CommonAPI::SomeIP::StringDeployment > _message) {
            if (_callback)
                _callback(_internalCallStatus, _message.getValue());
        },
        std::make_tuple(deploy_message));
}

void DemoApp1SomeIPProxy::DemoMethodErr1(std::string _name, CommonAPI::CallStatus &_internalCallStatus, DemoApp1::stdErrorTypeEnum &_error, std::string &_message, const CommonAPI::CallInfo *_info) {
    CommonAPI::Deployable< DemoApp1::stdErrorTypeEnum, ::v0::commonapi::demo::DemoApp1_::stdErrorTypeEnumDeployment_t> deploy_error(static_cast< ::v0::commonapi::demo::DemoApp1_::stdErrorTypeEnumDeployment_t * >(nullptr));
    CommonAPI::Deployable< std::string, CommonAPI::SomeIP::StringDeployment> deploy_name(_name, &::v0::commonapi::demo::DemoApp1_::DemoMethodErr1_nameDeployment);
    CommonAPI::Deployable< std::string, CommonAPI::SomeIP::StringDeployment> deploy_message(&::v0::commonapi::demo::DemoApp1_::DemoMethodErr1_messageDeployment);
    CommonAPI::SomeIP::ProxyHelper<
        CommonAPI::SomeIP::SerializableArguments<
            CommonAPI::Deployable<
                std::string,
                CommonAPI::SomeIP::StringDeployment
            >
        >,
        CommonAPI::SomeIP::SerializableArguments<
            CommonAPI::Deployable<
                DemoApp1::stdErrorTypeEnum,
                ::v0::commonapi::demo::DemoApp1_::stdErrorTypeEnumDeployment_t
            >,
            CommonAPI::Deployable<
                std::string,
                CommonAPI::SomeIP::StringDeployment
            >
        >
    >::callMethodWithReply(
        *this,
        CommonAPI::SomeIP::method_id_t(0x7531),
        false,
        false,
        (_info ? _info : &CommonAPI::SomeIP::defaultCallInfo),
        deploy_name,
        _internalCallStatus,
        deploy_error,
        deploy_message);
    _error = deploy_error.getValue();
    _message = deploy_message.getValue();
}

std::future<CommonAPI::CallStatus> DemoApp1SomeIPProxy::DemoMethodErr1Async(const std::string &_name, DemoMethodErr1AsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    CommonAPI::Deployable< DemoApp1::stdErrorTypeEnum, ::v0::commonapi::demo::DemoApp1_::stdErrorTypeEnumDeployment_t> deploy_error(static_cast< ::v0::commonapi::demo::DemoApp1_::stdErrorTypeEnumDeployment_t * >(nullptr));
    CommonAPI::Deployable< std::string, CommonAPI::SomeIP::StringDeployment> deploy_name(_name, &::v0::commonapi::demo::DemoApp1_::DemoMethodErr1_nameDeployment);
    CommonAPI::Deployable< std::string, CommonAPI::SomeIP::StringDeployment> deploy_message(&::v0::commonapi::demo::DemoApp1_::DemoMethodErr1_messageDeployment);
    return CommonAPI::SomeIP::ProxyHelper<
        CommonAPI::SomeIP::SerializableArguments<
            CommonAPI::Deployable<
                std::string,
                CommonAPI::SomeIP::StringDeployment
            >
        >,
        CommonAPI::SomeIP::SerializableArguments<
            CommonAPI::Deployable<
                DemoApp1::stdErrorTypeEnum,
                ::v0::commonapi::demo::DemoApp1_::stdErrorTypeEnumDeployment_t
            >,
            CommonAPI::Deployable<
                std::string,
                CommonAPI::SomeIP::StringDeployment
            >
        >
    >::callMethodAsync(
        *this,
        CommonAPI::SomeIP::method_id_t(0x7531),
        false,
        false,
        (_info ? _info : &CommonAPI::SomeIP::defaultCallInfo),
        deploy_name,
        [_callback] (CommonAPI::CallStatus _internalCallStatus, CommonAPI::Deployable< DemoApp1::stdErrorTypeEnum, ::v0::commonapi::demo::DemoApp1_::stdErrorTypeEnumDeployment_t > _deploy_error, CommonAPI::Deployable< std::string, CommonAPI::SomeIP::StringDeployment > _message) {
            if (_callback)
                _callback(_internalCallStatus, _deploy_error.getValue(), _message.getValue());
        },
        std::make_tuple(deploy_error, deploy_message));
}

void DemoApp1SomeIPProxy::DemoMethodTp1(std::string _name, std::vector< int32_t > _data, CommonAPI::CallStatus &_internalCallStatus, std::string &_message, const CommonAPI::CallInfo *_info) {
    CommonAPI::Deployable< std::string, CommonAPI::SomeIP::StringDeployment> deploy_name(_name, &::v0::commonapi::demo::DemoApp1_::DemoMethodTp1_nameDeployment);
    CommonAPI::Deployable< std::vector< int32_t >, CommonAPI::SomeIP::ArrayDeployment< CommonAPI::SomeIP::IntegerDeployment<int32_t> >> deploy_data(_data, static_cast< CommonAPI::SomeIP::ArrayDeployment< CommonAPI::SomeIP::IntegerDeployment<int32_t> >* >(nullptr));
    CommonAPI::Deployable< std::string, CommonAPI::SomeIP::StringDeployment> deploy_message(static_cast< CommonAPI::SomeIP::StringDeployment* >(nullptr));
    CommonAPI::SomeIP::ProxyHelper<
        CommonAPI::SomeIP::SerializableArguments<
            CommonAPI::Deployable<
                std::string,
                CommonAPI::SomeIP::StringDeployment
            >,
            CommonAPI::Deployable<
                std::vector< int32_t >,
                CommonAPI::SomeIP::ArrayDeployment< CommonAPI::SomeIP::IntegerDeployment<int32_t> >
            >
        >,
        CommonAPI::SomeIP::SerializableArguments<
            CommonAPI::Deployable<
                std::string,
                CommonAPI::SomeIP::StringDeployment
            >
        >
    >::callMethodWithReply(
        *this,
        CommonAPI::SomeIP::method_id_t(0x7532),
        false,
        false,
        (_info ? _info : &CommonAPI::SomeIP::defaultCallInfo),
        deploy_name, deploy_data,
        _internalCallStatus,
        deploy_message);
    _message = deploy_message.getValue();
}

std::future<CommonAPI::CallStatus> DemoApp1SomeIPProxy::DemoMethodTp1Async(const std::string &_name, const std::vector< int32_t > &_data, DemoMethodTp1AsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    CommonAPI::Deployable< std::string, CommonAPI::SomeIP::StringDeployment> deploy_name(_name, &::v0::commonapi::demo::DemoApp1_::DemoMethodTp1_nameDeployment);
    CommonAPI::Deployable< std::vector< int32_t >, CommonAPI::SomeIP::ArrayDeployment< CommonAPI::SomeIP::IntegerDeployment<int32_t> >> deploy_data(_data, static_cast< CommonAPI::SomeIP::ArrayDeployment< CommonAPI::SomeIP::IntegerDeployment<int32_t> >* >(nullptr));
    CommonAPI::Deployable< std::string, CommonAPI::SomeIP::StringDeployment> deploy_message(static_cast< CommonAPI::SomeIP::StringDeployment* >(nullptr));
    return CommonAPI::SomeIP::ProxyHelper<
        CommonAPI::SomeIP::SerializableArguments<
            CommonAPI::Deployable<
                std::string,
                CommonAPI::SomeIP::StringDeployment
            >,
            CommonAPI::Deployable<
                std::vector< int32_t >,
                CommonAPI::SomeIP::ArrayDeployment< CommonAPI::SomeIP::IntegerDeployment<int32_t> >
            >
        >,
        CommonAPI::SomeIP::SerializableArguments<
            CommonAPI::Deployable<
                std::string,
                CommonAPI::SomeIP::StringDeployment
            >
        >
    >::callMethodAsync(
        *this,
        CommonAPI::SomeIP::method_id_t(0x7532),
        false,
        false,
        (_info ? _info : &CommonAPI::SomeIP::defaultCallInfo),
        deploy_name, deploy_data,
        [_callback] (CommonAPI::CallStatus _internalCallStatus, CommonAPI::Deployable< std::string, CommonAPI::SomeIP::StringDeployment > _message) {
            if (_callback)
                _callback(_internalCallStatus, _message.getValue());
        },
        std::make_tuple(deploy_message));
}

void DemoApp1SomeIPProxy::getOwnVersion(uint16_t& ownVersionMajor, uint16_t& ownVersionMinor) const {
    ownVersionMajor = 0;
    ownVersionMinor = 1;
}

std::future<void> DemoApp1SomeIPProxy::getCompletionFuture() {
    return completed_.get_future();
}

} // namespace demo
} // namespace commonapi
} // namespace v0
